###########################################################################################
#                                   BoostShields.py
#   
#                       Boost Shields v0.1.1 by USS Sovereign -- 04/03/2006                           
#
#       Wow this mod turned out to be much larger than I thought. Okay sort description:
#
#       This mod allows the player to redirect power from main power to shields gaining
#       instant shield recharge. There's a 10 second delay between power transfer to shields
#       to add a bit of realism, after you've used the mod once you cannot use it for 45
#       seconds. Shields get recharged to full power when the mod is used most of the times
#       of course. Restart handlers for QB and QBR are included, it's QBR compatible also!
#
#       Authors: BCS: TNG
#
#       Credits: Defiant for QBautostart, Madon for giving me the idea with his Redistribute
#       Shields mod! Thanks man!
#
#       PROPERTY OF BCS: TNG, DO NOT MODIFY WITHOUT PERMISSION. 
#
###########################################################################################

# Globals and Imports and man there are lot of globals, many buttons 
import App 
import MissionLib
import Libs.LibEngineering
import Libs.BCSTNGLib
pMain = None
pForward = None
pRear = None
pTop = None
pBottom = None
pLeft = None
pRight = None
pAll = None
EnableTimer = None

# We need exactly 7 buttons for Front, Bottom, 6 shields and boost all button
def init():
        global pMain, pForward, pRear, pTop, pBottom, pLeft, pRight, pAll
        
        pMain = Libs.BCSTNGLib.CreateMenu("Boost Shields", "Tactical")

        # In order or appearence in BC All, Front, Rear, Bottom, Top, Left and Right
        pRight = Libs.BCSTNGLib.CreateButton("Boost Right", "Tactical", __name__ + ".BoostRight", "Boost Shields")
        pLeft = Libs.BCSTNGLib.CreateButton("Boost Left", "Tactical", __name__ + ".BoostLeft", "Boost Shields")
        pTop = Libs.BCSTNGLib.CreateButton("Boost Top", "Tactical", __name__ + ".BoostTop", "Boost Shields")
        pBottom = Libs.BCSTNGLib.CreateButton("Boost Bottom", "Tactical", __name__ + ".BoostBottom", "Boost Shields")
        pRear = Libs.BCSTNGLib.CreateButton("Boost Rear", "Tactical", __name__ + ".BoostRear", "Boost Shields")
        pForward = Libs.BCSTNGLib.CreateButton("Boost Front", "Tactical", __name__ + ".BoostFront", "Boost Shields")
        pAll = Libs.BCSTNGLib.CreateButton("Boost All", "Tactical", __name__ + ".BoostAll", "Boost Shields")

        

# We tested the code with this one so let's just copy it :)    
def BoostFront(pObject, pEvent):
        # we grab some values we need for this part
	pPlayer = MissionLib.GetPlayer()
	pShields = pPlayer.GetShields()
	pPower = pPlayer.GetPowerSubsystem()
	MainBatteryPower = pPower.GetMainBatteryPower()
	MainBatteryLimit = pPower.GetMainBatteryLimit()
	pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()

	
	# qb and qbr end combat handelers
        
        pSaffiQB = GetMenuButton("Commander", "End Combat")
        pSaffiQBR = GetQBRMenuButton("Commander", "Configure")

        # qb restart function, pretty much standard in BCS: TNG's mods
        
	if pSaffiQB:
                pSaffiQB.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

        # qbr restart function

        if pSaffiQBR:
                pSaffiQBR.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

        # restart really works now in both qb versions

        App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".BoostReset")
        App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")
 	

        # well for safety resons you cannot use it all the time
	if (MainBatteryPower <= (MainBatteryLimit*.05)):
            return

	# we just make sure that the shields are actually online if they're not then we'll just move on nothing will happen
	if (pShields.IsOn() and not pShields.IsDisabled()):

            # revised in the interest of fairnes we add a 7 second delay between power transfers
            # why 7 second, well it just popped onto my head and in the game 7 seconds isn't what it seems to be :P
            # edit 10 seconds is from now on!
            
            # play the line of course
            pGame = App.Game_GetCurrentGame()
            pEpisode = pGame.GetCurrentEpisode()
            pMission = pEpisode.GetCurrentMission()
            Database = pMission.SetDatabase("data/TGL/BoostShields.tgl")
            pSequence = App.TGSequence_Create()
            pSet = App.g_kSetManager.GetSet("bridge")
            pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
            pSequence.AppendAction(App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "TrPower", None, 0, Database))
            pSequence.Play()

            
            SetButtons()
            MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BoostFrontRevised", App.g_kUtopiaModule.GetGameTime() + 10, 0, 0)


def BoostFrontRevised(pObject, pEvent):
            # we grab some values we need for this part
            pPlayer = MissionLib.GetPlayer()
            pShields = pPlayer.GetShields()
            pPower = pPlayer.GetPowerSubsystem()
            MainBatteryPower = pPower.GetMainBatteryPower()
            MainBatteryLimit = pPower.GetMainBatteryLimit()

            # play the new sound
            pSound = App.TGSound_Create("sfx/Custom/BoostShields/EmergencyPwrEngaged.mp3", "EPE", 0)
            pSound.SetSFX(0) 
            pSound.SetInterface(1) 
            App.g_kSoundManager.PlaySound("EPE") 

            ShieldStrength = pPlayer.GetShields().GetMaxShields(App.ShieldClass.FRONT_SHIELDS)
            ShieldValue = ShieldStrength * 2
            # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
            # works but not like you thought it should, so we compromise like this
            ShieldCur = ShieldStrength * 4	
            pShields.BoostShield(App.ShieldClass.FRONT_SHIELDS, ShieldCur)
            # we also set drain power from main power 
            pPower.SetMainBatteryPower(MainBatteryPower - ShieldValue)
            

# pretty much the same routine for all shields we only recharge rear shields
def BoostRear(pObject, pEvent):
            # we grab some values we need for this part
            pPlayer = MissionLib.GetPlayer()
            pShields = pPlayer.GetShields()
            pPower = pPlayer.GetPowerSubsystem()
            MainBatteryPower = pPower.GetMainBatteryPower()
            MainBatteryLimit = pPower.GetMainBatteryLimit()
            pGame = App.Game_GetCurrentGame()
            pEpisode = pGame.GetCurrentEpisode()
            pMission = pEpisode.GetCurrentMission()

            # qb and qbr end combat handelers
        
            pSaffiQB = GetMenuButton("Commander", "End Combat")
            pSaffiQBR = GetQBRMenuButton("Commander", "Configure")

            # qb restart function, pretty much standard in BCS: TNG's mods
            
            if pSaffiQB:
                    pSaffiQB.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # qbr restart function

            if pSaffiQBR:
                    pSaffiQBR.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # restart really works now in both qb versions

            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".BoostReset")
            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")

            # well for safety resons you cannot use it all the time
            if (MainBatteryPower <= (MainBatteryLimit*.05)):
                return

            # we just make sure that the shields are actually online if they're not then we'll just move on nothing will happen
            if (pShields.IsOn() and not pShields.IsDisabled()):
                            
                # play the line of course
                pGame = App.Game_GetCurrentGame()
                pEpisode = pGame.GetCurrentEpisode()
                pMission = pEpisode.GetCurrentMission()
                Database = pMission.SetDatabase("data/TGL/BoostShields.tgl")
                pSequence = App.TGSequence_Create()
                pSet = App.g_kSetManager.GetSet("bridge")
                pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
                pSequence.AppendAction(App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "TrPower", None, 0, Database))
                pSequence.Play()
                
                SetButtons()
                MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BoostRearRevised", App.g_kUtopiaModule.GetGameTime() + 10, 0, 0)

def BoostRearRevised(pObject, pEvent):
                # we grab some values we need for this part
                pPlayer = MissionLib.GetPlayer()
                pShields = pPlayer.GetShields()
                pPower = pPlayer.GetPowerSubsystem()
                MainBatteryPower = pPower.GetMainBatteryPower()
                MainBatteryLimit = pPower.GetMainBatteryLimit()

                # play the new sound
                pSound = App.TGSound_Create("sfx/Custom/BoostShields/EmergencyPwrEngaged.mp3", "EPE", 0)
                pSound.SetSFX(0) 
                pSound.SetInterface(1) 
                App.g_kSoundManager.PlaySound("EPE") 
                
                ShieldStrength = pPlayer.GetShields().GetMaxShields(App.ShieldClass.REAR_SHIELDS)
                ShieldValue = ShieldStrength * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur = ShieldStrength * 4	
                pShields.BoostShield(App.ShieldClass.REAR_SHIELDS, ShieldCur)
                # we also set drain power from main power 
                pPower.SetMainBatteryPower(MainBatteryPower - ShieldValue)
                

# top shield
def BoostTop(pObject, pEvent):
            # we grab some values we need for this part
            pPlayer = MissionLib.GetPlayer()
            pShields = pPlayer.GetShields()
            pPower = pPlayer.GetPowerSubsystem()
            MainBatteryPower = pPower.GetMainBatteryPower()
            MainBatteryLimit = pPower.GetMainBatteryLimit()
            pGame = App.Game_GetCurrentGame()
            pEpisode = pGame.GetCurrentEpisode()
            pMission = pEpisode.GetCurrentMission()

            # qb and qbr end combat handelers
        
            pSaffiQB = GetMenuButton("Commander", "End Combat")
            pSaffiQBR = GetQBRMenuButton("Commander", "Configure")

            # qb restart function, pretty much standard in BCS: TNG's mods
            
            if pSaffiQB:
                    pSaffiQB.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # qbr restart function

            if pSaffiQBR:
                    pSaffiQBR.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # restart really works now in both qb versions

            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".BoostReset")
            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")


            # well for safety resons you cannot use it all the time
            if (MainBatteryPower <= (MainBatteryLimit*.05)):
                return

            # we just make sure that the shields are actually online if they're not then we'll just move on nothing will happen
            if (pShields.IsOn() and not pShields.IsDisabled()):

                # play the line of course
                pGame = App.Game_GetCurrentGame()
                pEpisode = pGame.GetCurrentEpisode()
                pMission = pEpisode.GetCurrentMission()
                Database = pMission.SetDatabase("data/TGL/BoostShields.tgl")
                pSequence = App.TGSequence_Create()
                pSet = App.g_kSetManager.GetSet("bridge")
                pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
                pSequence.AppendAction(App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "TrPower", None, 0, Database))
                pSequence.Play()

            
                SetButtons()
                MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BoostTopRevised", App.g_kUtopiaModule.GetGameTime() + 10, 0, 0)

def BoostTopRevised(pObject, pEvent):
                # we grab some values we need for this part
                pPlayer = MissionLib.GetPlayer()
                pShields = pPlayer.GetShields()
                pPower = pPlayer.GetPowerSubsystem()
                MainBatteryPower = pPower.GetMainBatteryPower()
                MainBatteryLimit = pPower.GetMainBatteryLimit()

                # play the new sound
                pSound = App.TGSound_Create("sfx/Custom/BoostShields/EmergencyPwrEngaged.mp3", "EPE", 0)
                pSound.SetSFX(0) 
                pSound.SetInterface(1) 
                App.g_kSoundManager.PlaySound("EPE")
                
                ShieldStrength = pPlayer.GetShields().GetMaxShields(App.ShieldClass.TOP_SHIELDS)
                ShieldValue = ShieldStrength * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur = ShieldStrength * 4	
                pShields.BoostShield(App.ShieldClass.TOP_SHIELDS, ShieldCur)
                # we also set drain power from main power 
                pPower.SetMainBatteryPower(MainBatteryPower - ShieldValue)
                

# bottom shields, dorsal etc. well it's not in my vocabulary and i'm not an american :P
def BoostBottom(pObject, pEvent):
            # we grab some values we need for this part
            pPlayer = MissionLib.GetPlayer()
            pShields = pPlayer.GetShields()
            pPower = pPlayer.GetPowerSubsystem()
            MainBatteryPower = pPower.GetMainBatteryPower()
            MainBatteryLimit = pPower.GetMainBatteryLimit()
            pGame = App.Game_GetCurrentGame()
            pEpisode = pGame.GetCurrentEpisode()
            pMission = pEpisode.GetCurrentMission()

            # qb and qbr end combat handelers
        
            pSaffiQB = GetMenuButton("Commander", "End Combat")
            pSaffiQBR = GetQBRMenuButton("Commander", "Configure")

            # qb restart function, pretty much standard in BCS: TNG's mods
            
            if pSaffiQB:
                    pSaffiQB.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # qbr restart function

            if pSaffiQBR:
                    pSaffiQBR.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # restart really works now in both qb versions

            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".BoostReset")
            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")


            # well for safety resons you cannot use it all the time
            if (MainBatteryPower <= (MainBatteryLimit*.05)):
                return

            # we just make sure that the shields are actually online if they're not then we'll just move on nothing will happen
            if (pShields.IsOn() and not pShields.IsDisabled()):
                # play the line of course
                pGame = App.Game_GetCurrentGame()
                pEpisode = pGame.GetCurrentEpisode()
                pMission = pEpisode.GetCurrentMission()
                Database = pMission.SetDatabase("data/TGL/BoostShields.tgl")
                pSequence = App.TGSequence_Create()
                pSet = App.g_kSetManager.GetSet("bridge")
                pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
                pSequence.AppendAction(App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "TrPower", None, 0, Database))
                pSequence.Play()
                
                SetButtons()
                MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BoostBottomRevised", App.g_kUtopiaModule.GetGameTime() + 10, 0, 0)

def BoostBottomRevised(pObject, pEvent):
                # we grab some values we need for this part
                pPlayer = MissionLib.GetPlayer()
                pShields = pPlayer.GetShields()
                pPower = pPlayer.GetPowerSubsystem()
                MainBatteryPower = pPower.GetMainBatteryPower()
                MainBatteryLimit = pPower.GetMainBatteryLimit()

                # play the new sound
                pSound = App.TGSound_Create("sfx/Custom/BoostShields/EmergencyPwrEngaged.mp3", "EPE", 0)
                pSound.SetSFX(0) 
                pSound.SetInterface(1) 
                App.g_kSoundManager.PlaySound("EPE")
                
                ShieldStrength = pPlayer.GetShields().GetMaxShields(App.ShieldClass.BOTTOM_SHIELDS)
                ShieldValue = ShieldStrength * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur = ShieldStrength * 4	
                pShields.BoostShield(App.ShieldClass.BOTTOM_SHIELDS, ShieldCur)
                # we also set drain power from main power 
                pPower.SetMainBatteryPower(MainBatteryPower - ShieldValue)


# left shields
def BoostLeft(pObject, pEvent):
            # we grab some values we need for this part
            pPlayer = MissionLib.GetPlayer()
            pShields = pPlayer.GetShields()
            pPower = pPlayer.GetPowerSubsystem()
            MainBatteryPower = pPower.GetMainBatteryPower()
            MainBatteryLimit = pPower.GetMainBatteryLimit()
            pGame = App.Game_GetCurrentGame()
            pEpisode = pGame.GetCurrentEpisode()
            pMission = pEpisode.GetCurrentMission()

            # qb and qbr end combat handelers
        
            pSaffiQB = GetMenuButton("Commander", "End Combat")
            pSaffiQBR = GetQBRMenuButton("Commander", "Configure")

            # qb restart function, pretty much standard in BCS: TNG's mods
            
            if pSaffiQB:
                    pSaffiQB.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # qbr restart function

            if pSaffiQBR:
                    pSaffiQBR.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # restart really works now in both qb versions

            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".BoostReset")
            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")


            # well for safety resons you cannot use it all the time
            if (MainBatteryPower <= (MainBatteryLimit*.05)):
                return

            # we just make sure that the shields are actually online if they're not then we'll just move on nothing will happen
            if (pShields.IsOn() and not pShields.IsDisabled()):
                # play the line of course
                pGame = App.Game_GetCurrentGame()
                pEpisode = pGame.GetCurrentEpisode()
                pMission = pEpisode.GetCurrentMission()
                Database = pMission.SetDatabase("data/TGL/BoostShields.tgl")
                pSequence = App.TGSequence_Create()
                pSet = App.g_kSetManager.GetSet("bridge")
                pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
                pSequence.AppendAction(App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "TrPower", None, 0, Database))
                pSequence.Play()
                
                SetButtons()
                MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BoostLeftRevised", App.g_kUtopiaModule.GetGameTime() + 10, 0, 0)

def BoostLeftRevised(pObject, pEvent):
                # we grab some values we need for this part
                pPlayer = MissionLib.GetPlayer()
                pShields = pPlayer.GetShields()
                pPower = pPlayer.GetPowerSubsystem()
                MainBatteryPower = pPower.GetMainBatteryPower()
                MainBatteryLimit = pPower.GetMainBatteryLimit()

                # play the new sound
                pSound = App.TGSound_Create("sfx/Custom/BoostShields/EmergencyPwrEngaged.mp3", "EPE", 0)
                pSound.SetSFX(0) 
                pSound.SetInterface(1) 
                App.g_kSoundManager.PlaySound("EPE")
                
                ShieldStrength = pPlayer.GetShields().GetMaxShields(App.ShieldClass.LEFT_SHIELDS)
                ShieldValue = ShieldStrength * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur = ShieldStrength * 4	
                pShields.BoostShield(App.ShieldClass.LEFT_SHIELDS, ShieldCur)
                # we also set drain power from main power 
                pPower.SetMainBatteryPower(MainBatteryPower - ShieldValue)


# right shields
def BoostRight(pObject, pEvent):
            # we grab some values we need for this part
            pPlayer = MissionLib.GetPlayer()
            pShields = pPlayer.GetShields()
            pPower = pPlayer.GetPowerSubsystem()
            MainBatteryPower = pPower.GetMainBatteryPower()
            MainBatteryLimit = pPower.GetMainBatteryLimit()
            pGame = App.Game_GetCurrentGame()
            pEpisode = pGame.GetCurrentEpisode()
            pMission = pEpisode.GetCurrentMission()

            # qb and qbr end combat handelers
        
            pSaffiQB = GetMenuButton("Commander", "End Combat")
            pSaffiQBR = GetQBRMenuButton("Commander", "Configure")

            # qb restart function, pretty much standard in BCS: TNG's mods
            
            if pSaffiQB:
                    pSaffiQB.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # qbr restart function

            if pSaffiQBR:
                    pSaffiQBR.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # restart really works now in both qb versions

            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".BoostReset")
            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")


            # well for safety resons you cannot use it all the time
            if (MainBatteryPower <= (MainBatteryLimit*.05)):
                return

            # we just make sure that the shields are actually online if they're not then we'll just move on nothing will happen
            if (pShields.IsOn() and not pShields.IsDisabled()):

                # play the line of course
                pGame = App.Game_GetCurrentGame()
                pEpisode = pGame.GetCurrentEpisode()
                pMission = pEpisode.GetCurrentMission()
                Database = pMission.SetDatabase("data/TGL/BoostShields.tgl")
                pSequence = App.TGSequence_Create()
                pSet = App.g_kSetManager.GetSet("bridge")
                pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
                pSequence.AppendAction(App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "TrPower", None, 0, Database))
                pSequence.Play()
                
                SetButtons()
                MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BoostRightRevised", App.g_kUtopiaModule.GetGameTime() + 10, 0, 0)


def BoostRightRevised(pObject, pEvent):
                # we grab some values we need for this part
                pPlayer = MissionLib.GetPlayer()
                pShields = pPlayer.GetShields()
                pPower = pPlayer.GetPowerSubsystem()
                MainBatteryPower = pPower.GetMainBatteryPower()
                MainBatteryLimit = pPower.GetMainBatteryLimit()

                # play the new sound
                pSound = App.TGSound_Create("sfx/Custom/BoostShields/EmergencyPwrEngaged.mp3", "EPE", 0)
                pSound.SetSFX(0) 
                pSound.SetInterface(1) 
                App.g_kSoundManager.PlaySound("EPE")
                
                ShieldStrength = pPlayer.GetShields().GetMaxShields(App.ShieldClass.RIGHT_SHIELDS)
                ShieldValue = ShieldStrength * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur = ShieldStrength * 4	
                pShields.BoostShield(App.ShieldClass.RIGHT_SHIELDS, ShieldCur)
                # we also set drain power from main power 
                pPower.SetMainBatteryPower(MainBatteryPower - ShieldValue)


# now all shields but at a greater cost and smaller recharge rate also high power cost
def BoostAll(pObject, pEvent):
            # we grab some values we need for this part
            pPlayer = MissionLib.GetPlayer()
            pShields = pPlayer.GetShields()
            pPower = pPlayer.GetPowerSubsystem()
            MainBatteryPower = pPower.GetMainBatteryPower()
            MainBatteryLimit = pPower.GetMainBatteryLimit()
            pGame = App.Game_GetCurrentGame()
            pEpisode = pGame.GetCurrentEpisode()
            pMission = pEpisode.GetCurrentMission()

            # qb and qbr end combat handelers
        
            pSaffiQB = GetMenuButton("Commander", "End Combat")
            pSaffiQBR = GetQBRMenuButton("Commander", "Configure")

            # qb restart function, pretty much standard in BCS: TNG's mods
            
            if pSaffiQB:
                    pSaffiQB.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # qbr restart function

            if pSaffiQBR:
                    pSaffiQBR.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

            # restart really works now in both qb versions

            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".BoostReset")
            App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")


            # well for safety resons you cannot use it all the time
            if (MainBatteryPower <= (MainBatteryLimit*.05)):
                return

            # we just make sure that the shields are actually online if they're not then we'll just move on nothing will happen
            if (pShields.IsOn() and not pShields.IsDisabled()):
                # play the line of course
                pGame = App.Game_GetCurrentGame()
                pEpisode = pGame.GetCurrentEpisode()
                pMission = pEpisode.GetCurrentMission()
                Database = pMission.SetDatabase("data/TGL/BoostShields.tgl")
                pSequence = App.TGSequence_Create()
                pSet = App.g_kSetManager.GetSet("bridge")
                pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
                pSequence.AppendAction(App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "TrPower", None, 0, Database))
                pSequence.Play()
                
                SetButtons()
                MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BoostAllRevised", App.g_kUtopiaModule.GetGameTime() + 10, 0, 0)

def BoostAllRevised(pObject, pEvent):
                # we grab some values we need for this part
                pPlayer = MissionLib.GetPlayer()
                pShields = pPlayer.GetShields()
                pPower = pPlayer.GetPowerSubsystem()
                MainBatteryPower = pPower.GetMainBatteryPower()
                MainBatteryLimit = pPower.GetMainBatteryLimit()

                # play the new sound
                pSound = App.TGSound_Create("sfx/Custom/BoostShields/EmergencyPwrEngaged.mp3", "EPE", 0)
                pSound.SetSFX(0) 
                pSound.SetInterface(1) 
                App.g_kSoundManager.PlaySound("EPE")
                
                # this code is more lenghty but safer so we do all shield checks at once and reinforce them
                ShieldStrength1 = pPlayer.GetShields().GetMaxShields(App.ShieldClass.FRONT_SHIELDS)
                ShieldValue1 = ShieldStrength1 * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur1 = ShieldStrength1 * 3	
                pShields.BoostShield(App.ShieldClass.FRONT_SHIELDS, ShieldCur1)
                
                ShieldStrength2 = pPlayer.GetShields().GetMaxShields(App.ShieldClass.REAR_SHIELDS)
                ShieldValue2 = ShieldStrength2 * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur2 = ShieldStrength2 * 3	
                pShields.BoostShield(App.ShieldClass.REAR_SHIELDS, ShieldCur2)

                ShieldStrength3 = pPlayer.GetShields().GetMaxShields(App.ShieldClass.TOP_SHIELDS)
                ShieldValue3 = ShieldStrength3 * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur3 = ShieldStrength3 * 3	
                pShields.BoostShield(App.ShieldClass.TOP_SHIELDS, ShieldCur3)

                ShieldStrength4 = pPlayer.GetShields().GetMaxShields(App.ShieldClass.BOTTOM_SHIELDS)
                ShieldValue4 = ShieldStrength4 * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur4 = ShieldStrength4 * 3	
                pShields.BoostShield(App.ShieldClass.BOTTOM_SHIELDS, ShieldCur4)

                ShieldStrength5 = pPlayer.GetShields().GetMaxShields(App.ShieldClass.LEFT_SHIELDS)
                ShieldValue5 = ShieldStrength5 * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur5 = ShieldStrength5 * 3	
                pShields.BoostShield(App.ShieldClass.LEFT_SHIELDS, ShieldCur5)

                ShieldStrength6 = pPlayer.GetShields().GetMaxShields(App.ShieldClass.RIGHT_SHIELDS)
                ShieldValue6 = ShieldStrength6 * 2
                # so in order to boost shields we get max shield strength and multiply it 4 times to get some reasonable results, the boost shield code
                # works but not like you thought it should, so we compromise like this
                ShieldCur6 = ShieldStrength6 * 3	
                pShields.BoostShield(App.ShieldClass.RIGHT_SHIELDS, ShieldCur6)

                # now we just simply do a simple math over here and get total ammount of spent power
                ShieldValues =  ShieldValue1 + ShieldValue2 + ShieldValue3 + ShieldValue4 + ShieldValue5 + ShieldValue6
                
                # we also set drain power from main power 
                pPower.SetMainBatteryPower(MainBatteryPower - ShieldValues)



# we disable all buttons for sometime to add more balance and realism, you cannot transfer power all the time a 30 second delay is included
def SetButtons():
                global pForward, pRear, pTop, pBottom, pLeft, pRight, pAll, EnableTimer

                pForward.SetDisabled()
                pRear.SetDisabled()
                pTop.SetDisabled()
                pBottom.SetDisabled()
                pLeft.SetDisabled()
                pRight.SetDisabled()
                pAll.SetDisabled()

                EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EnableButtons", App.g_kUtopiaModule.GetGameTime() + 45, 0, 0)
            
        
# we reenable buttons now
def EnableButtons(pObject, pEvent):
                global pForward, pRear, pTop, pBottom, pLeft, pRight, pAll
                
                pForward.SetEnabled()
                pRear.SetEnabled()
                pTop.SetEnabled()
                pBottom.SetEnabled()
                pLeft.SetEnabled()
                pRight.SetEnabled()
                pAll.SetEnabled()

                
# standard in bcs: tng scripts
def ShipExploding(pObject, pEvent):
                pPlayer = App.Game_GetCurrentGame().GetPlayer()

                # Get the ship that is exploding.
                pShip = App.ShipClass_Cast(pEvent.GetDestination())
                if (pShip != None):
                        iShipID = pShip.GetObjID()
                        if pPlayer and pShip.GetName() == pPlayer.GetName():
                                # It's us.  Reset.
                                BoostReset(None, None)

# well a simple reset function
def BoostReset(pObject, pEvent):
        global EnableTimer
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()

        # delete enable button timer
        try:
                App.g_kTimerManager.DeleteTimer(EnableTimer.GetObjID())
                App.g_kRealtimeTimerManager.DeleteTimer(EnableTimer.GetObjID())
                EnableTimer = None

        except:
                pass

        # reenable buttons
        EnableButtons(None, None)

        # reset our end combat handelers

        pSaffiQB = GetMenuButton("Commander", "End Combat")
        pSaffiQBR = GetQBRMenuButton("Commander", "Configure")
        
        if pSaffiQB:
                pSaffiQB.RemoveHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")

        if pSaffiQBR:
                pSaffiQBR.RemoveHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".BoostReset")
            
        App.g_kEventManager.RemoveBroadcastHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")
        App.g_kEventManager.RemoveBroadcastHandler(App.ET_SET_PLAYER, pMission, __name__ + ".BoostReset")
        

# wowy's originally developed code with print's disabled :P
def GetMenuButton(sMenuName, sButtonName):
        pMenu = GetBridgeMenu(sMenuName)
        if not pMenu:
                return

        # Grab the starting button.    
        pButton = pMenu.GetButton(sButtonName)
        if not pButton:
                pButton = pMenu.GetSubmenu(sButtonName)
                if not pButton: 
                        return
        return pButton


# From ATP_GUIUtils:

def GetBridgeMenu(menuName):
	pTactCtrlWindow = App.TacticalControlWindow_GetTacticalControlWindow()
	pDatabase = App.g_kLocalizationManager.Load("data/TGL/Bridge Menus.tgl")
	if(pDatabase is None):
		return
	return pTactCtrlWindow.FindMenu(pDatabase.GetString(menuName))

# get the qbr menu button 

def GetQBRMenuButton(sMenuName, sButtonName):
        pMenu = GetBridgeMenu(sMenuName)
        if not pMenu:
                return

        # Grab the starting button.    
        pButton = pMenu.GetButton(sButtonName)
        if not pButton:
                pButton = pMenu.GetSubmenu(sButtonName)
                if not pButton: 
                        return
        return pButton


# From ATP_GUIUtils to get qbr button modified by USS Sovereign

def GetQBRBridgeMenu(menuName):
	pTactCtrlWindow = App.TacticalControlWindow_GetTacticalControlWindow()
	pDatabase = App.g_kLocalizationManager.Load("data/TGL/QBRrestart.tgl")
	if(pDatabase is None):
		return
	return pTactCtrlWindow.FindMenu(pDatabase.GetString(menuName))

# THE END!
                
                
